<?php
/***************************************************************************
 *   awEventCalendar                                                       *
 *                                                                         *
 *   Copyright (C) 2006-2008 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
require_once('../../maincore.php');
require_once(BASEDIR.'subheader.php');
require_once(BASEDIR.'side_left.php');

if(!iSUPERADMIN) {
	fallback('calendar.php');
}

require_once('include/common.php');


/*
 * ACTION
 */
if(isset($_POST['save'])) {
	$need_admin_ok = (isset($_POST['need_admin_ok']) ? "1" : "0");
	$s_today_in_panel = (isset($_POST['show_today_in_panel']) ? "1" : "0");
	$s_birthday_in_panel = (isset($_POST['show_birthday_in_panel']) ? "1" : "0");
	$edit_group = intval($_POST['edit_group']);
	if(!$edit_group) {
		$edit_group = "103";
	}
	$post_group = intval($_POST['post_group']);
	if(!$post_group) {
		$edit_group = "101";
	}
	$b_group = intval($_POST['b_group']);

	$next_days = intval($_POST['next_days']);

	$b_date_fmt = stripinput($_POST['b_date_fmt']);
	$date_fmt = stripinput($_POST['date_fmt']);
	$s_date_fmt = stripinput($_POST['sidedate_fmt']);
	$time_fmt = stripinput($_POST['time_fmt']);

	$sun_first_dow = (isset($_POST['sun_first_dow']) ? "yes" : "no");

	$ok = dbquery("UPDATE ".DB_PREFIX."aw_ec_settings
		SET
		need_admin_ok='".$need_admin_ok."',
		show_today_in_panel='".$s_today_in_panel."',
		show_birthday_in_panel='".$s_birthday_in_panel."',
		edit_group='".$edit_group."',
		post_group='".$post_group."',
		show_birthday_to_group='".$b_group."',
		birthdate_fmt='".$b_date_fmt."',
		next_days_in_panel='".$next_days."',
		sun_first_dow='".$sun_first_dow."',
		sidedate_fmt='".$s_date_fmt."',
		date_fmt='".$date_fmt."',
		time_fmt='".$time_fmt."'");
	if($ok) {
		redirect(FUSION_SELF.'?errno=0');
	}
}




/*
 * GUI
 */
opentable($locale['EC700']);
ec_menu();
echo '
<div style="text-align:right;">
	<strong><code>awEventCalendar '.$ec_settings['version'].'</code></strong>
</div>';

require_once('include/db_update.php');


if(isset($_GET['errno']) && isset($locale['EC717'][$_GET['errno']])) {
	show_info($locale['EC717'][$_GET['errno']]);
}


if(file_exists('tooltips.js')) {
	show_info('FIXME: pls delete tooltips.js');
}
if(file_exists('cross.js')) {
	show_info('FIXME: pls delete cross.js');
}



// all groups
$usergroups = getusergroups();
$sel_edit_group = '';
$sel_post_group = '';
$sel_b_group = '';
foreach($usergroups as $group) {
	list($gid, $gname) = $group;

	$sel_b_group .= '
	<option value="'.$gid.'"'
		.($gid==$ec_settings['show_birthday_to_group']
			? ' selected="selected"'
			: '')
		.'>'.$gname.'</option>';

	if(!$gid) {
		continue;
	}
	$sel_edit_group .= '
		<option value="'.$gid.'"'
			.($gid==$ec_settings['edit_group']
				? ' selected="selected"'
				: '')
			.'>'.$gname.'</option>';
	$sel_post_group .= '
		<option value="'.$gid.'"'
			.($gid==$ec_settings['post_group']
				? ' selected="selected"'
				: '')
			.'>'.$gname.'</option>';
}


//	$result_2 = dbquery("SELECT * FROM ".DB_PREFIX."kalender_settings");
//	$data_v = dbarray($result_2);

$query_id = dbquery("SELECT
	DATE_FORMAT(NOW(), '".$ec_settings['birthdate_fmt']."') AS b_date,
	DATE_FORMAT(NOW(), '".$ec_settings['date_fmt']."') AS s_date,
	TIME_FORMAT(NOW(), '".$ec_settings['time_fmt']."') AS s_time
	"
	);
$fmt_sample = dbarray($query_id);
$fmt_sample['sidedate_fmt'] = ec_format_fucking_date(date('Y'), date('m'), date('d'));


echo '
<form method="post" action="'.FUSION_SELF.'">
<table width="100%">
<colgroup>
	<col width="200" />
	<col width="*" />
</colgroup>
<tbody>
'."
<tr>
	<td>".$locale['EC701'].":</td>
	<td><select name='edit_group' class='textbox'>"
		.$sel_edit_group."</select></td>
</tr>
<tr>
	<td>".$locale['EC703'].":</td>
	<td><select name='post_group' class='textbox'>"
		.$sel_post_group."</select></td>
</tr>
<tr>
	<td>".$locale['EC722'].":</td>
	<td><input type='text' name='next_days' class='textbox' size='4'"
		." value='".$ec_settings['next_days_in_panel']."'"
		." maxlength='3'></td>
</tr>
<tr>
	<td valign='top'>".$locale['EC706'].":</td>
	<td><select name='b_group' class='textbox'>"
		.$sel_b_group."</select><br>"
		."<input type='checkbox' name='show_birthday_in_panel'"
		.($ec_settings['show_birthday_in_panel'] ? " checked" : "")
		.">".$locale['EC705']."</td>
</tr>
<tr>
	<td valign='top'>".$locale['EC106'].":</td>
	<td><input type='checkbox' name='need_admin_ok'"
		.($ec_settings['need_admin_ok'] ? " checked" : "")
		.">".$locale['EC702']
		."<br>"
		."<input type='checkbox' name='show_today_in_panel'"
			.($ec_settings['show_today_in_panel'] ? " checked" : "")
			.">".$locale['EC704']
		."<br>"
		."<input type='checkbox' name='sun_first_dow'"
			.($ec_settings['sun_first_dow']=="yes" ? " checked" : "")
			.">".$locale['EC723']
	."</td>
</tr>
</tbody>
</table>


".'
<fieldset>
<legend>'.$locale['EC711'].'</legend>
<table width="100%">
<colgroup>
	<col width="200" />
	<col width="*" />
</colgroup>
<tbody>
<tr>
	<td>'.$locale['EC712'].':</td>
	<td><input type="text" class="textbox" name="b_date_fmt"
		size="30" maxlength="50"
		value="'.$ec_settings['birthdate_fmt'].'"> '
		.$locale['EC720'].": ".$fmt_sample['b_date'].'</td>
</tr>
<tr>
	<td>'.$locale['EC713'].':</td>
	<td><input type="text" class="textbox" name="date_fmt"
		size="30" maxlength="50"
		value="'.$ec_settings['date_fmt'].'"> '
		.$locale['EC720'].": ".$fmt_sample['s_date'].'</td>
</tr>
<tr>
	<td>'.$locale['EC726'].':</td>
	<td><input type="text" class="textbox" name="time_fmt"
		size="30" maxlength="50"
		value="'.$ec_settings['time_fmt'].'"> '
		.$locale['EC720'].': '.$fmt_sample['s_time'].'</td>
</tr>
<tr>
	<td></td>
	<td><span class="small2">'.nl2br($locale['EC719']).'</span></td>
</tr>
<tr>
	<td>'.$locale['EC724'].':</td>
	<td><input type="text" class="textbox" name="sidedate_fmt"
		size="30" maxlength="50"
		value="'.$ec_settings['sidedate_fmt'].'"> '
		.$locale['EC720'].': '.$fmt_sample['sidedate_fmt'].'</td>
</tr>
<tr>
	<td></td>
	<td><span class="small2">'.$locale['EC725'].': '
		.implode(', ', $ec_supported).'</span></td>
</tr>
</tbody>
</table>
</fieldset>

<p></p>
<input type="submit" value="'.$locale['EC111'].'" name="save" class="button">

</form>';
closetable();


require_once(BASEDIR.'side_right.php');
require_once(BASEDIR.'footer.php');
?>
