<?php
/***************************************************************************
 *   awEventCalendar                                                       *
 *                                                                         *
 *   Copyright (C) 2006-2008 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
require_once('../../maincore.php');
require_once(BASEDIR.'subheader.php');
require_once(BASEDIR.'side_left.php');

if(!iMEMBER) {
	fallback('calendar.php');
}

require_once('include/common.php');

if(!iEC_POST) {
	fallback('calendar.php');
}





/*
 * GET
 */
$action = FUSION_SELF;
if(isset($_GET['id'])) {
	if(!isNum($_GET['id'])) {
		fallback('index.php');
	}

	$res = dbquery("SELECT ev_id, ev_title, ev_body, ev_repeat, ev_private,
			ev_allow_logins, ev_max_logins, ev_login_access,
			ev_no_smileys, ev_status,
			ev_access, ev_start,
			ev_start_time, ev_end_time
		FROM ".DB_PREFIX."aw_ec_events
		WHERE ev_id='".$_GET['id']."'"
			.(iEC_ADMIN
				? ''
				: " AND user_id='".$userdata['user_id']."'"
			));
	if(!dbrows($res)) {
		fallback('calendar.php');
	}
	$event = dbarray($res);
	$action .= '?id='.$event['ev_id'];

} else {
	$event = array(
		'ev_id'			=> 0,
		//
		'ev_status'		=> '0',
		'ev_title'		=> '',
		'ev_body'		=> '',
		'ev_repeat'		=> 0,
		'ev_private'		=> 0,
		'ev_allow_logins'	=> 0,
		'ev_max_logins'		=> 0,
		'ev_login_access'	=> 0,
		'ev_no_smileys'		=> 0,
		'ev_access'		=> 0,
		'ev_start'		=> date('Y-m-d').' 00:00:00',
		'ev_start_time'		=> '',
		'ev_end_time'		=> '',
	);
}



$errors = array();



/****************************************************************************
 * ACTION
 */
if(isset($_POST['save'])) {
	$event['ev_title'] = trim(stripinput($_POST['title']));
	$event['ev_body'] = trim(stripinput($_POST['desc']));
	if(empty($event['ev_title']) || empty($event['ev_body'])) {
		$errors[] = $locale['EC119'];
	}
	$event['ev_access'] = intval($_POST['access']);
	$event['ev_no_smileys'] = (isset($_POST['disable_smileys']) ? '1' : '0');

	$event['ev_start'] = ec_get_date($_POST, 'start');
	$event['ev_end'] = $event['ev_start'];
	if(!$event['ev_start']) {
		$errors[] = $locale['EC113'][EC_EDATE];
	}

	$event['ev_start_time'] = ec_get_time($_POST, 'start_time');
	$event['ev_end_time'] = ec_get_time($_POST, 'end_time');

	$event['ev_allow_logins'] = (isset($_POST['allow_logins']) ? '1' : '0');
	$event['ev_max_logins'] = intval($_POST['max_logins']);
	$event['ev_login_access'] = intval($_POST['login_access']);
	if(!$event['ev_login_access']
		|| !ec_check_access($event['ev_login_access']))
	{
		$event['ev_login_access'] = 101;
	}

	$event['ev_repeat'] = intval($_POST['repeat']);
	$event['ev_private'] = (isset($_POST['is_private']) ? '1' : '0');


	$now = time();
	if($event['ev_private'] || iEC_ADMIN) {
		$status = '0';
	} else {
		$status = ($ec_settings['need_admin_ok'] ? '1' : '0');
	}

	if($event['ev_private']) {
		if($event['ev_allow_logins']) {
			$event['ev_allow_logins'] = '0';
			$event['ev_max_logins'] = '0';
			$event['ev_login_access'] = '101';
			$errors[] = $locale['EC113'][EC_ELOGIN];
//FIXME			$errno = EC_ELOGIN;
		}
		if($event['ev_access']) {
			$event['ev_access'] = '0';
			$errors[] = $locale['EC113'][EC_EACCESS];
//FIXME			$errno = EC_EACCESS;
		}
	}

	if(count($errors)==0) {
		if(!$event['ev_id']) {
			dbquery("INSERT INTO ".DB_PREFIX."aw_ec_events
				SET
				user_id='".$userdata['user_id']."',
				ev_timestamp='".$now."',
				ev_body=''");
			$event['ev_id'] = mysql_insert_id();
		}

		$ok = dbquery("UPDATE ".DB_PREFIX."aw_ec_events
			SET
			ev_title='".$event['ev_title']."',
			ev_body='".$event['ev_body']."',
			ev_start='".$event['ev_start']."',
			ev_end='".$event['ev_end']."',
			ev_start_time=".$event['ev_start_time'].",
			ev_end_time=".$event['ev_end_time'].",
			ev_repeat='".$event['ev_repeat']."',
			ev_private='".$event['ev_private']."',
			ev_status='".$status."',
			ev_no_smileys='".$event['ev_no_smileys']."',
			ev_allow_logins='".$event['ev_allow_logins']."',
			ev_max_logins='".$event['ev_max_logins']."',
			ev_access='".$event['ev_access']."',
			ev_login_access='".$event['ev_login_access']."'
			WHERE ev_id='".$event['ev_id']."'");
		if($ok) {
			fallback('edit_event.php?id='.$event['ev_id']
				.'&errno=0');
		}
	}

} elseif(isset($_GET['del']) && iEC_ADMIN && $event['ev_id']) {
	$ok = dbquery("DELETE FROM ".DB_PREFIX."aw_ec_events
		WHERE ev_id='".$event['ev_id']."'");
	if($ok) {
		$ok = dbquery("DELETE FROM ".DB_PREFIX."aw_ec_logins
			WHERE ev_id='".$event['ev_id']."'");
	}
	if($ok) {
		if(isset($_GET['back_to'])) {
			fallback('new_events.php');
		} else {
			fallback('calendar.php');
		}
	}

} elseif(isset($_GET['status']) && $event['ev_id'] && isset($_GET['time'])
	&& isNum($_GET['time']) && iEC_ADMIN)
{
	$ok = dbquery("UPDATE ".DB_PREFIX."aw_ec_events
		SET
		ev_status=MOD(ev_status+1, 2)
		WHERE ev_id='".$event['ev_id']."'
			AND ev_timestamp='".$_GET['time']."'");
	if($ok) {
		if(isset($_GET['back_to'])) {
			fallback("new_events.php");
		} else {
			fallback('edit_event.php?id='.$event['ev_id']);
		}
	}
}



/****************************************************************************
 * FUNCS
 */
function ec_make_date($date, $fname) {
	global $locale;

	$year = substr($date, 0, 4);
	$mon = substr($date, 5, 2);
	$mday = substr($date, 8, 2);

	$sel_day = '';
	$sel_month = '';

	// day
	for($i=1; $i<=31; ++$i) {
		$sel_day .= '
			<option value="'.$i.'"'
				.($i==$mday
					? ' selected="selected"'
					: '')
			.'>'.$i.'</option>';
	}
	// month
	for($i=1; $i<=12; ++$i) {
		$sel_month .= '
			<option value="'.$i.'"'
				.($i==$mon
					? ' selected="selected"'
					: '')
			.'>'.$locale['EC900'][$i].'</option>';
	}

	return '
<select class="textbox" name="'.$fname.'[mday]">'.$sel_day.'
</select>
.
<select class="textbox" name="'.$fname.'[month]">'.$sel_month.'
</select>
.
<input type="text" class="textbox" name="'.$fname.'[year]"
	value="'.$year.'" size="5" maxlength="4">';
}


function ec_make_time($time, $fname) {
	global $locale;

	if($time) {
		$hours = substr($time, 0, 2);
		$mins = substr($time, 3, 2);
	} else {
		$hours = $mins = -1;
	}

	$sel_mins = $sel_hours = '<option value="-1">--</option>';

	// hours
	for($i=0; $i<=23; ++$i) {
		$sel_hours .= '
			<option value="'.$i.'"'
				.($i==$hours
					? ' selected="selected"'
					: '')
			.'>'.$i.'</option>';
	}
	// mins
	for($i=0; $i<=59; ++$i) {
		$sel_mins .= '
			<option value="'.$i.'"'
				.($i==$mins
					? ' selected="selected"'
					: '')
				.'>'.$i.'</option>';
	}

	return '
<select class="textbox" name="'.$fname.'[hours]">'.$sel_hours.'
</select>
:
<select class="textbox" name="'.$fname.'[mins]">'.$sel_mins.'
</select>';
}

// returns 'NULL' or 'time in quotes'
function ec_get_time($data, $fname) {
	if(!isset($data[$fname]) || !isset($data[$fname]['hours'])
		|| !isset($data[$fname]['mins']))
	{
		return 'NULL';
	}
	if($data[$fname]['hours']<0 || $data[$fname]['mins']<0) {
		return 'NULL';
	}

	return sprintf("'%02d:%02d:00'",
		intval($data[$fname]['hours']),
		intval($data[$fname]['mins']));
}
// returns false on failure 'date in quotes'
function ec_get_date($data, $fname) {
	if(!isset($data[$fname]) || !isset($data[$fname]['year'])
		|| !isset($data[$fname]['month'])
		|| !isset($data[$fname]['mday']))
	{
		return false;
	}

	return sprintf("%04d-%02d-%02d 00:00:00",
		intval($data[$fname]['year']),
		intval($data[$fname]['month']),
		intval($data[$fname]['mday']));
}


/*
function ec_get_timestamp($fname) {
	return mktime($_POST[$fname."_hours"], $_POST[$fname."_mins"], 0,
		$_POST[$fname."_month"], $_POST[$fname."_mday"],
		$_POST[$fname."_year"]);
}
*/



/****************************************************************************
 * GUI
 */
$sel_access = '';
$sel_login_access = '';
$fusion_groups = getusergroups();
foreach($fusion_groups as $group) {
	list($gid, $gname) = $group;
	if(!ec_check_access($gid)) {
		continue;
	}

	$sel_access .= '
		<option value="'.$gid.'"'
			.($gid==$event['ev_access']
				? ' selected="selected"'
				: ''
		).'>'.$gname.'</option>';

	if(!$gid) {
		continue;
	}
	$sel_login_access .= '
		<option value="'.$gid.'"'
			.($gid==$event['ev_login_access']
				? ' selected="selected"'
				: ''
		).'>'.$gname.'</option>';
}

$sel_repeat = '';
foreach($locale['EC125'] as $rep => $text) {
	$sel_repeat .= '
		<option value="'.$rep.'"'
			.($rep==$event['ev_repeat']
				? ' selected="selected"'
				: '')
		.'>'.$text.'</option>';
}



/****************************************************************************
 * GUI
- <input type='button' value='".EC_BREAK."' class='button' onClick=\"insertText('comment_message', '".EC_BREAK."');\">\n";
 */
opentable($event['ev_id'] ? $locale['EC101'] : $locale['EC100']);
ec_menu();


if($event['ev_id']) {
	echo '
<div style="text-align:right">
<a href="view_event.php?id='.$event['ev_id'].'">'.$locale['EC102'].'</a>';
	if(iADMIN) {
		echo '
| <a href="'.$action.'&amp;status=1">'
	.($event['ev_status']
		? $locale['EC306']
		: $locale['EC307'])
	.'</a>';
	}
	echo '
</div>';
}


if(count($errors)) {
	show_info($errors);
}
if(isset($errno) && isset($locale['EC113'][$errno])) {
	show_info($locale['EC113'][$errno]);
}



if($event['ev_status']) {
	show_info($locale['EC113'][EC_ESTATUS]);
}



echo '
<p>
<span class="small2">'.$locale['awec_mandatory'].'</span>
</p>

<form action="'.$action.'" method="post" name="inputform">

<p></p>
<label>'.$locale['EC103'].': *</label><br />
<input type="text" name="title" value="'.$event['ev_title'].'" class="textbox"
	size="60" maxlength="200" />

<p></p>
<table border="0" cellpadding="2" cellspacing="1" class="tbl-border">
<tbody>
<tr class="tbl1">
	<td><label>'.$locale['awec_date'].': *</label></td>
	<td><label>'.$locale['awec_beginn'].':</label></td>
	<td><label>'.$locale['awec_end'].':</label></td>
	<td><label>'.$locale['EC107'].':</label></td>
</tr>
<tr class="tbl2">
	<td>'.ec_make_date($event['ev_start'], 'start').'</td>
	<td>'.ec_make_time($event['ev_start_time'], 'start_time').'</td>
	<td>'.ec_make_time($event['ev_end_time'], 'end_time').'</td>
	<td>
		<select class="textbox" name="repeat">'.$sel_repeat.'
		</select>
	</td>
</tr>
<tr class="tbl2">
	<td><span class="small2">'.$locale['awec_date_fmt'].'</span></td>
	<td><span class="small2">'.$locale['awec_time_fmt'].'</span></td>
	<td><span class="small2">'.$locale['awec_time_fmt'].'</span></td>
	<td></td>
</tr>
</tbody>
</table>


<p></p>
<label>'.$locale['EC116'].':</label><br />
<select class="textbox" name="access">'.$sel_access.'
</select>
<input type="checkbox" name="is_private"'
	.($event['ev_private']
		? ' checked="checked"'
		: '')
	.'><label>'.$locale['EC108'].'</label>



<p></p>
<label>'.$locale['EC104'].': *</label><br />
<span class="small2">'.$locale['awec_break'].'</span><br />
<textarea name="desc" rows="8" class="textbox" cols="60">'
	.$event['ev_body'].'</textarea>
<br />
'.ec_get_bb_smileys('desc', true, $event['ev_no_smileys']).'



<!-- logins -->
<p></p>
<fieldset>
<legend>
	<input type="checkbox" name="allow_logins"'
		.($event['ev_allow_logins']
			? ' checked="checked"'
			: '')
		.'> '.$locale['EC109'].'
</legend>

<p></p>
<label>'.$locale['EC110'].':</label><br />
<input type="text" class="textbox" name="max_logins"
	value="'.$event['ev_max_logins'].'" size="5" maxlength="5">
<span class="small2">'.$locale['EC110_1'].'</span>

<p></p>
<label>'.$locale['EC116'].':</label><br />
<select name="login_access" class="textbox">'.$sel_login_access.'
</select>

</fieldset>


<p></p>
<input type="submit" name="save" class="button" value="'.$locale['EC111'].'">

</form>';
closetable();


require_once(BASEDIR.'side_right.php');
require_once(BASEDIR.'footer.php');
?>
