<?php
/***************************************************************************
 *   awEventCalendar                                                       *
 *                                                                         *
 *   Copyright (C) 2006-2008 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
if(!defined('IN_FUSION')) {
	die();
}
define('EC_BREAK',	'---br---');

define('EC_REP_YEAR',	1);// repeat on that day and month every year
define('EC_REP_MONTH',	2);// repeat on that day every month
define('EC_REP_WEEK',	4);// repeat on that day of week


//0: no error
define('EC_ELOGIN',	1);
define('EC_EDB',	2);
define('EC_ESTATUS',	3);
define('EC_EACCESS',	4);
define('EC_EIMG',	5);
define('EC_EDATE',	6);


if(file_exists(INFUSIONS.'aw_ecal_panel/locale/'.$settings['locale'].'.php')) {
	include(INFUSIONS.'aw_ecal_panel/locale/'.$settings['locale'].'.php');
} else {
	include(INFUSIONS.'aw_ecal_panel/locale/German.php');
}


// settings
$query_id = dbquery("SELECT * FROM ".DB_PREFIX."aw_ec_settings");
$ec_settings = dbarray($query_id);
$ec_supported = array('%d', '%e', '%m', '%c', '%Y', '%y');


define("PIC_PATH",	INFUSIONS."aw_ecal_panel/pics/");
define('iEC_ADMIN',	ec_check_access($ec_settings['edit_group']));
define("iEC_POST",	iEC_ADMIN || ec_check_access($ec_settings['post_group']));


define('EC_BULLET',	'<img src="'.THEME.'images/bullet.gif" alt="-">');


unset($ec_year, $ec_month, $ec_mday);
if(isset($_GET['y']) && isNum($_GET['y'])) {
	$ec_year = $_GET['y'];
} else {
	$ec_year = date('Y');
}
if(isset($_GET['m']) && isNum($_GET['m'])) {
	$ec_month = $_GET['m'];
} else {
	$ec_month = date('n');
}
if(isset($_GET['d']) && isNum($_GET['d'])) {
	$ec_mday = $_GET['d'];
} else {
	$ec_mday = date('j');
}


// today - not the same that is shown in the calendar.
$ec_today = getdate(time());
$ec_is_this_month = ($ec_today['mon']==$ec_month && $ec_today['year']==$ec_year);
$ec_tomorrow = getdate(time()+60*60*24);



/*
 * FUNCS
 */
/*
 * extended: with php-fusion user table
 * return value: number of events in $events
 */
function ec_get_events($year, $month, $day, &$events, $extended=true)
{
	global $userdata, $ec_settings;

	$elem = array();
	$and_where = array();

	$where = array();

	// where
	if($month) {
		$where[] = "(ev_repeat='".EC_REP_MONTH."'"
			." OR MONTH(ev_start)='$month')";
	}
	if($day) {
		$where[] = "DAYOFMONTH(ev_start)='$day'";
	}
	if($year) {
		$where[] = "(ev_repeat='".EC_REP_YEAR."'"
			." OR YEAR(ev_start)='$year')";
	}
	$where = implode(" AND ", $where);
	$and_where[] = "(ev_repeat='".EC_REP_WEEK."'"
		." OR ev_repeat='".EC_REP_MONTH."' OR ($where))";


	// access - edit group - no access limit
	if(iEC_ADMIN) {
		//
	} elseif(iMEMBER) {
		$and_where[] = "(((ev_status='0' AND ev_private='0')"
			." OR ec.user_id='".$userdata['user_id']."')"
			." AND ".groupaccess("ev_access").")";
	} else {
		$and_where[] = "(ev_status='0' AND ev_private='0'"
			." AND ev_access='0')";
	}

	$query = "SELECT DAYOFMONTH(ev_start) AS day, ev_repeat,
		ev_title, ev_id, ev_access, YEAR(ev_start) AS year,
		MONTH(ev_start) AS month, DAYOFWEEK(ev_start) AS wday,
		ev_private, ec.user_id, ev_timestamp,";
	if($extended) {
		$query .= " user_name, ev_allow_logins, ev_status,";
	}
	$query .= "ev_body,
		DATE_FORMAT(ev_start_time, '".$ec_settings['time_fmt']."') AS start_time,
		DATE_FORMAT(ev_end_time, '".$ec_settings['time_fmt']."') AS end_time,
		DATE_FORMAT(ev_start,
			'".$ec_settings['date_fmt']."') AS date,
		ev_no_smileys
		FROM ".DB_PREFIX."aw_ec_events AS ec";
	if($extended) {
		$query .= " LEFT JOIN ".DB_PREFIX."users USING(user_id)";
	}
	if(count($where)) {
		$query .= " WHERE ".implode(" AND ", $and_where);
	}
	$query .= " ORDER BY DAYOFMONTH(ev_start) ASC, ev_start_time ASC";
//FIXME	if($month==0) {
//FIXME	echo "<pre>$query</pre>";
//FIXME	}

	$query_id = dbquery($query);
	while($ev = dbarray($query_id)) {
		$ev_id = $ev['ev_id'];
		$elem = $ev;

		// repeat weekly events
		if($ev['ev_repeat']==EC_REP_WEEK) {
			if($month) {
				$from_mon = $to_mon = $month;
			} else {
				$from_mon = 1;
				$to_mon = 12;
			}
			for($m=$from_mon; $m<=$to_mon; ++$m) {
				$mon_time = mktime(12, 0, 0, $m, 1, $year);
				$first_wday = date('w', $mon_time);
				$last_mday = date('t', $mon_time);

				for($d=$ev['wday']-$first_wday; $d<=$last_mday;
					$d+=7) {
					if($d>0) {
						$events[$year][$m][$d][$ev_id]
							= $elem;
					}
				}
			}
		} elseif($ev['ev_repeat']==EC_REP_MONTH) {
			if($month==0) {
				// need monthly repetitions
				for($m=1; $m<=12; ++$m) {
					$mon_time = mktime(12, 0, 0, $m, 1, $year);
					$last_mday = date('t', $mon_time);

					if($ev['day']<=$last_mday) {
						$events[$year][$m][$ev['day']][$ev_id]
							= $elem;
					}
				}
			} else {
				$events[$year][$month][$ev['day']][$ev_id] = $elem;
			}
		} else {
			$events[$year][$ev['month']][$ev['day']][$ev_id] = $elem;
		}
	}

	return count($events);
}



function ec_check_access($group_id) {
	if(iSUPERADMIN) {
		return true;
	}
        switch($group_id) {
        case 101: return iMEMBER;
        case 102: return iADMIN;
        case 103: return iSUPERADMIN;
        default:  return checkGroup($group_id);
        }
	return checkGroup($id);
}


function ec_render_cal($month, $year, $title, $content,
	$height, $show_others, $sun_first_day)
{
	global $locale;

	$dow_from = 1;
	$dow_to = 7;
	$dow_offset = -1;
	if($sun_first_day) {
		$dow_from = 0;
		$dow_to = 6;
		$dow_offset = 0;
	}

	if($height>0) {
		$height = ' height="'.$height.'"';
	} else {
		$height = '';
	}

	//
	$thismonth = mktime(12, 0, 0, $month, 1, $year);
	$date = getdate($thismonth);

	if(!$sun_first_day && $date['wday']==0) {
		$date['wday'] = 7;
	}
	$offset = $date['wday'] + $dow_offset;

	$daysinmonth = date("t", $thismonth);

	/*
	 * line by line
	 */
	echo '
<div style="text-align:center;">'.$title.'</div>';

	echo '
<table class="awec_table" cellspacing="1" width="100%">
<colgroup>
	<col width="13%" span="7" />
</colgroup>
<thead>';
//	echo "<caption>".$locale['EC400']."</caption>\n";

	// days of week
	echo '
<tr>';
	for($i=$dow_from; $i<=$dow_to; ++$i) {
		echo '
	<td class="awec_dayofweek">'.$locale['EC901'][$i].'</td>';
	}
	echo '
</tr>
</thead>
<tbody>';

	// start with offset
	echo '
<tr'.$height.'>';
	for($i=0; $i<$offset; ++$i) {
		echo '
	<td class="awec_empty">&nbsp;</td>';
	}
	// start month
	$col = $offset;
	for($i=1; $i<=$daysinmonth; ++$i) {
		if($sun_first_day) {
			if($col==0 || $col==6) {
				$content[$i]['style'] .= ' awec_weekend';
			}
		} else {
			if($col==5 || $col==6) {
				$content[$i]['style'] .= ' awec_weekend';
			}
		}
		echo '
	<td class="'.$content[$i]['style'].'" valign="top">'
			.$content[$i]['data'].'</td>';

		// new line
		if((++$col%7)==0) {
			echo '
</tr>
<tr'.$height.'>';
			$col = 0;
		}
	}
	for($i=0; $i<(7-$col); $i++) {
		echo '
	<td class="awec_empty">&nbsp;</td>';
	}
	echo '
</tr>
</tbody>
</table>';
}


function ec_format_fucking_date($year, $month, $mday) {
	global $ec_supported, $ec_settings;

	$ret = $ec_settings['sidedate_fmt'];

	$conv = array(
		'%d'	=> sprintf('%02d', $mday),
		'%e'	=> sprintf('%d', $mday),
		'%m'	=> sprintf('%02d', $month),
		'%c'	=> sprintf('%d', $month),
		'%Y'	=> sprintf('%04d', $year),
		'%y'	=> sprintf('%02d', $year),
	);

	foreach($conv as $field => $fmt) {
		$ret = str_replace($field, $fmt, $ret);
	}

	return $ret;
}

?>
